<TeXmacs|1.99.3>

<style|<tuple|beamer|mathemagix|vdh|pari|caas|math-ss>>

<\body>
  <\hide-preamble>
    <assign|smash*|<macro|body|<vresize|<arg|body>|0ex|1.5ex>>>
  </hide-preamble>

  <screens|<\shown>
    <\with|par-mode|center>
      <strong|<\with|font-base-size|15>
        <strong|Preserving Syntactic Correctness<new-line>While Editing
        Mathematical Formulas>
      </with>>

      <strong|Joris van der Hoeven>, Grgoire Lecerf, Denis Raux

      <small|CNRS, cole polytechnique>
    </with>

    <\with|par-mode|center>
      <tabular*|<tformat|<cwith|1|1|2|2|cell-valign|c>|<table|<row|<cell|
      >|<cell|>|<cell|>>|<row|<cell|>|<cell|<img|<image|texmacs-chip.ps|0.6w|0.6h||>>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<strong|Kalamata,
      July 20, 2015<rsub|<math|<rsub|>>>>>|<cell|>>|<row|<cell|>|<cell|<verbatim|http://www.<anim-repeat|<anim-compose|<anim-constant|<with|color|brown|T<space|-0.2spc><with|color|brown|<rsub|<with|math-level|0|font-shape|small-caps|e>>>X<space|-0.2spc>><with|color|dark
      green|<rsub|<with|math-level|0|font-shape|small-caps|m<space|-0.2spc>a<space|-0.4spc>c<space|-0.2spc>s>>>|1sec>|<anim-constant|<with|color|dark
      green|T<space|-0.2spc><with|color|brown|<rsub|<with|math-level|0|font-shape|small-caps|e>>>X<space|-0.2spc>><with|color|brown|<rsub|<with|math-level|0|font-shape|small-caps|m<space|-0.2spc>a<space|-0.4spc>c<space|-0.2spc>s>>>|1sec>>>.org>>|<cell|>>>>>
    </with>

    \;
  </shown>|<\hidden>
    <tit|Different levels of semantics>

    \;

    <\overlays|1|6>
      <tabular*|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|1|-1|cell-bsep|2spc>|<cwith|1|-1|1|-1|cell-tsep|2spc>|<cwith|2|2|1|3|cell-halign|c>|<cwith|2|2|1|3|cell-bsep|2spc>|<cwith|2|2|1|3|cell-tsep|2spc>|<cwith|1|-1|1|1|cell-width|0.33par>|<cwith|1|-1|1|1|cell-hmode|exact>|<cwith|1|-1|2|2|cell-width|0.33par>|<cwith|1|-1|2|2|cell-hmode|exact>|<cwith|1|-1|3|3|cell-width|0.33par>|<cwith|1|-1|3|3|cell-hmode|exact>|<table|<row|<cell|No
      semantics>|<cell|<LaTeX>>|<cell|<tabular*|<tformat|<table|<row|<cell|Code>>|<row|<cell|<verbatim|$a+bc$>>>>>>>>|<row|<cell|<overlay-from|2|Presentation
      semantics|>>|<cell|<overlay-from|2|<tabular*|<tformat|<table|<row|<cell|Presentation
      MathML>>|<row|<cell|Classical <TeXmacs>>>>>>|>>|<cell|<overlay-from|2|<tabular*|<tformat|<table|<row|<cell|Specification>>|<row|<cell|<verbatim|a+b*c>>>>>>|>>>|<row|<cell|<overlay-from|6|<with|color|red|Syntactical
      semantics>|>>|<cell|<tabular*|<tformat|<table|<row|<cell|<overlay-from|6|<with|color|red|Experimental
      <TeXmacs>>|>>>|<row|<cell|<overlay-from|6|<with|color|red|Various CAS
      systems>|>>>>>>>|<cell|<overlay-from|6|<with|color|red|Grammar
      enhanced>|>>>|<row|<cell|<overlay-from|3|Content
      semantics|>>|<cell|<overlay-from|3|Content
      MathML|>>|<cell|<overlay-from|3|<tabular*|<tformat|<table|<row|<cell|Syntax
      tree>>|<row|<cell|<verbatim|(+ a (* b
      c))>>>>>>|>>>|<row|<cell|<overlay-from|4|Concept
      semantics|>>|<cell|<overlay-from|4|OpenMath|>>|<cell|<overlay-from|4|<tabular*|<tformat|<table|<row|<cell|Annotated
      tree>>|<row|<cell|<verbatim|+ commutative,
      ...>>>>>>|>>>|<row|<cell|<overlay-from|5|Full
      semantics|>>|<cell|<overlay-from|5|Coq, Hol,
      ...|>>|<cell|<overlay-from|5|Proof script|>>>>>>
    </overlays>

    \;
  </hidden>|<\hidden>
    <tit|Different types of mathematical texts>

    \;

    <\itemize>
      <unroll|<\shown>
        <item><with|color|dark blue|Computer algebra formulas and programs>

        Restricted grammars; possibility to design <em|ad hoc> editors for a
        fixed grammar<vspace|1fn>
      </shown>|<\hidden*>
        <item><with|color|dark blue|Formally correct mathematical texts>

        Flexible grammars; focus on proofs, not on presentation or
        readability<vspace|1fn>
      </hidden*>|<\hidden*>
        <item><with|color|dark blue|Informal, general purpose mathematical
        texts>

        Very flexible notations; emphasis on user friendliness for authors
      </hidden*>>
    </itemize>
  </hidden>|<\hidden>
    <tit|Three editing levels inside <TeXmacs>, demo>

    \;

    <switch|<\shown>
      <strong|Classical <TeXmacs>>

      <unroll|<\shown>
        \;

        <\equation*>
          x<rsub|1,2>=<frac|-b\<pm\><sqrt|b<rsup|2>-4*a*c>|2*a>
        </equation*>
      </shown>|<\hidden*>
        <\equation*>
          M=*<matrix|<tformat|<table|<row|<cell|\<lambda\><rsub|1>>|<cell|>|<cell|>>|<row|<cell|>|<cell|\<ddots\>>|<cell|>>|<row|<cell|>|<cell|>|<cell|\<lambda\><rsub|n>>>>>>
        </equation*>
      </hidden*>|<\hidden*>
        \;

        <\equation*>
          \<varphi\>=<cfrac|1|1+<cfrac|1|1+<cfrac|1|1+<cfrac|1|1+<cfrac|1|1+\<ddots\>>>>>>
        </equation*>
      </hidden*>>
    </shown>|<\hidden>
      <strong|Semantically aware <TeXmacs>>

      <unroll|<\shown>
        \;

        <\equation*>
          x<rsub|1,2>=<frac|-b\<pm\><sqrt|b<rsup|2>-4*a*c>|2*a>
        </equation*>
      </shown>|<\hidden*>
        <\equation*>
          M=<matrix|<tformat|<table|<row|<cell|\<lambda\><rsub|1>>|<cell|>|<cell|>>|<row|<cell|>|<cell|\<ddots\>>|<cell|>>|<row|<cell|>|<cell|>|<cell|\<lambda\><rsub|n>>>>>>
        </equation*>
      </hidden*>|<\hidden*>
        \;

        <\equation*>
          \<varphi\>=<cfrac|1|1+<cfrac|1|1+<cfrac|1|1+<cfrac|1|1+<cfrac|1|1+\<ddots\>>>>>>
        </equation*>
      </hidden*>>
    </hidden>|<\hidden>
      <strong|Enforcing semantic correctness>

      <unroll|<\shown>
        \;

        <\equation*>
          x<rsub|1,2>=<frac|-b\<pm\><sqrt|b<rsup|2>-4*a*c>|2*a>
        </equation*>
      </shown>|<\hidden*>
        <\equation*>
          M=<matrix|<tformat|<table|<row|<cell|\<lambda\><rsub|1>>|<cell|>|<cell|>>|<row|<cell|>|<cell|\<ddots\>>|<cell|>>|<row|<cell|>|<cell|>|<cell|\<lambda\><rsub|n>>>>>>
        </equation*>
      </hidden*>|<\hidden*>
        \;

        <\equation*>
          \<varphi\>=<cfrac|1|1+<cfrac|1|1+<cfrac|1|1+<cfrac|1|1+<cfrac|1|1+\<ddots\>>>>>>
        </equation*>
      </hidden*>>
    </hidden>>
  </hidden>|<\hidden>
    <tit|Challenges>

    <\itemize>
      <unroll|<\shown>
        <item><strong|Presentation oriented editing>

        <\itemize-minus>
          <item>Making editor as graphical as possible

          <item>Design efficient and easy to remember keyboard shortcuts

          <item>Include powerful macro system for new notations<vspace|1fn>
        </itemize-minus>
      </shown>|<\hidden*>
        <item><strong|Checking syntactic correctness>

        <\itemize-minus>
          <item>Design of a \Puniversal grammar\Q for informal mathematical
          notations

          <item>Compatability with macro system for the introduction of new
          notations<vspace|1fn>
        </itemize-minus>
      </hidden*>|<\hidden*>
        <item><strong|Enforcing syntactic correctness while editing>

        <\itemize-minus>
          <item>How to add/remove \Ptransient markup\Q in order to maintain
          correctness?

          <item>Guarantee same editing behaviour as for the presentation
          oriented mode

          <item>Guarantee correctness for <em|all> editing operations
        </itemize-minus>
      </hidden*>>
    </itemize>
  </hidden>|<\hidden>
    <tit|Ideal scheme to preserve correctness>

    <unroll|<\shown>
      \;

      <\quote-env>
        <\framed>
          <\enumerate>
            <item>Write a procedure \Pcorrect\Q, taking any formula on input
            and returning its correction, modulo inserting/removing transient
            markup only.

            <item>For each editing operation, apply the procedure \Pcorrect\Q
            to all modified formulas in all documents.
          </enumerate>
        </framed>
      </quote-env>
    </shown>|<\hidden*>
      \;

      \;

      <strong|Problems>

      <\itemize>
        <unroll|<\shown>
          <item>Writing the procedure \Pcorrect\Q is non trivial
        </shown>|<\hidden*>
          <item>How to select \Pbest\Q correction among all possible
          corrections
        </hidden*>|<\hidden*>
          <item>Strict application violates transparency <abbr|w.r.t.>
          presentation oriented editing:

          <\eqnarray*>
            <tformat|<table|<row|<cell|a+<suppressed|<tiny-box>><cursor>>|<cell|<long-arrow|\<rubber-rightarrow\>|<key|_>>>|<cell|a+<suppressed|<tiny-box>><rsub|<suppressed|<tiny-box>><cursor>>>>|<row|<cell|>|<cell|>|<cell|a+<rsub|<suppressed|<tiny-box>><cursor>><suppressed|<tiny-box>>>>>>
          </eqnarray*>
        </hidden*>>
      </itemize>
    </hidden*>>

    \;
  </hidden>|<\hidden>
    <tit|Multiple correction schemes >

    <unroll|<\shown>
      \;

      <\quote-env>
        <\framed>
          <\enumerate>
            <item><math|\<forall\>> editing action, determine a list of
            eligible correction schemes.

            <item>Try each eligible correction scheme until obtaining a
            correct formula.

            <item>If no schemes succeeded, then cancel the editing action.
          </enumerate>
        </framed>
      </quote-env>

      \;
    </shown>|<\hidden*>
      <strong|Challenges>

      <\itemize>
        <unroll|<\shown>
          <item>Design suitable correction schemes for the most common
          editing actions.
        </shown>|<\hidden*>
          <item>Completeness (so that step 3 is never reached).
        </hidden*>|<\hidden*>
          <item>Compatibility with \Pundo/redo\Q mechanism.
        </hidden*>|<\hidden*>
          <item>Correctness under all circumstances (<abbr|e.g.> editing
          operations that modify several formulas).
        </hidden*>>
      </itemize>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Examples>

    <unroll|<\shown>
      <\ornamented-titled>
        <\compact>
          <\itemize>
            <item>Remove transient markup around cursor

            <item>Apply insertion

            <item>Insert transient box at cursor position if needed
          </itemize>
        </compact>
      </ornamented-titled|<with|color|pastel yellow|Basic insertion scheme>>

      <\equation*>
        <cursor><space|1em><long-arrow|\<rubber-rightarrow\>|<key|a>><space|1em>a<cursor><space|1em><long-arrow|\<rubber-rightarrow\>|<key|+>><space|1em>a+<cursor><suppressed|<tiny-box>><space|1em><long-arrow|\<rubber-rightarrow\>|<key|b>><space|1em>a+b<cursor>
      </equation*>
    </shown>|<\hidden*>
      <\ornamented-titled>
        <\compact>
          <\itemize>
            <item>Move to the left of transient markup around cursor

            <item>Apply insertion

            <item>Insert transient box at cursor position if needed
          </itemize>
        </compact>
      </ornamented-titled|<with|color|pastel yellow|Starting a prime or right
      script after a transient box>>

      <\equation*>
        x+<suppressed|<tiny-box>><cursor><space|1em><long-arrow|\<rubber-rightarrow\>|<key|_><rsub|1>><space|1em>x+<cursor><suppressed|<tiny-box>><space|1em><long-arrow|\<rubber-rightarrow\>|<key|_><rsub|2>><space|1em>x+<rsub|<cursor>><suppressed|<tiny-box>><space|1em><long-arrow|\<rubber-rightarrow\>|<key|_><rsub|3>><space|1em>x+<rsub|<cursor><suppressed|<tiny-box>>><suppressed|<tiny-box>>
      </equation*>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Examples (continued)>

    <unroll|<\shown>
      <\ornamented-titled>
        <\compact>
          <\itemize>
            <item>Remove transient markup around cursor

            <item>Insert transient \Pexplicit spaces\Q before and after the
            cursor

            <item>Perform the insertion

            <item>Add further transient boxes if needed
          </itemize>
        </compact>
      </ornamented-titled|<with|color|pastel yellow|Insert content in the
      middle of an operator>>

      <\equation*>
        arc<cursor>sin<space|1em><long-arrow|\<rubber-rightarrow\>|<key|A-f><rsub|1>><space|1em>arc<suppressed|<explicit-space>><cursor><suppressed|<explicit-space>>sin<space|1em><long-arrow|\<rubber-rightarrow\>|<key|A-f><rsub|2>><space|1em>arc<suppressed|<explicit-space>><frac|<cursor>|><suppressed|<explicit-space>>sin<space|1em><long-arrow|\<rubber-rightarrow\>|<key|A-f><rsub|3>><space|1em>arc<suppressed|<explicit-space>><frac|<cursor><suppressed|<tiny-box>>|<suppressed|<tiny-box>>><suppressed|<explicit-space>>sin
      </equation*>
    </shown>|<\hidden*>
      <\ornamented-titled>
        <\compact>
          <\itemize>
            <item>Remove transient markup around cursor

            <item>Perform the deletion

            <item>Add transient version of the deleted infix operator after
            the cursor

            <item>Add further transient boxes if needed
          </itemize>
        </compact>
      </ornamented-titled|<with|color|pastel yellow|Removal of actual infix
      operators>>

      <\equation*>
        a+<cursor>b<space|1em><long-arrow|\<rubber-rightarrow\>|<key|backspace><rsub|1>><space|1em>a<cursor>b<space|1em><long-arrow|\<rubber-rightarrow\>|<key|backspace><rsub|2>><space|1em>a<cursor><suppressed|+>b
      </equation*>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Remaining problems and challenges>

    <\itemize>
      <unroll|<\shown>
        <item><strong|Informal content>

        <\eqnarray*>
          <tformat|<table|<row|<cell|Z>|<cell|=>|<cell|<around*|{|i\<in\>I:f<rsub|i><around*|(|x|)>=0<math-and|<text|<stack|<tformat|<cwith|1|1|1|1|cell-background|yellow>|<table|<row|<cell|and>>>>>>>g<rsub|i><around*|(|x|)>=0<text|
          <stack|<tformat|<cwith|1|1|1|1|cell-background|yellow>|<table|<row|<cell|almost
          everywhere>>>>>>|}>>>|<row|<cell|<stack|<tformat|<cwith|1|1|1|1|cell-background|yellow>|<table|<row|<cell|<space|1em>>>>>>>|<cell|=>|<cell|<around*|{|i\<in\>I:<around*|(|f<rsub|i><rsup|2>+g<rsub|i><rsup|2>|)><around*|(|x|)>=0<text|
          <stack|<tformat|<cwith|1|1|1|1|cell-background|yellow>|<table|<row|<cell|almost
          everywhere>>>>>>|}><stack|<tformat|<cwith|1|1|1|1|cell-background|yellow>|<table|<row|<cell|.>>>>>>>>>
        </eqnarray*>
      </shown>|<\hidden*>
        <item><strong|Missing schemes for \Pweird\Q editing operations>

        <\equation*>
          <tabular*|<tformat|<cwith|1|-1|1|-1|cell-lsep|2spc>|<cwith|1|-1|1|-1|cell-rsep|2spc>|<cwith|2|2|1|-1|cell-tsep|1spc>|<table|<row|<cell|a<cursor>>|<cell|<long-arrow|\<rubber-rightarrow\>|<key|A-^>>>|<cell|a<wide|<cursor>|^>>|<cell|<long-arrow|\<rubber-rightarrow\>|<key|+>>>|<cell|a<wide|+<cursor>|^>>|<cell|<long-arrow|\<rubber-rightarrow\>|<key|right>>>|<cell|a<wide|+|^><cursor>>|<cell|<long-arrow|\<rubber-rightarrow\>|<key|b>>>|<cell|a<wide|+|^>b<cursor>>>|<row|<cell|a<cursor>>|<cell|>|<cell|a<suppressed|<explicit-space>><wide|<smash*|<cursor><suppressed|<tiny-box>>>|^>>|<cell|>|<cell|a<suppressed|<explicit-space>><wide|<smash*|<suppressed|<tiny-box>>+<cursor><suppressed|<tiny-box>>>|^>>|<cell|>|<cell|a<suppressed|<explicit-space>><wide|<smash*|<suppressed|<tiny-box>>+<suppressed|<tiny-box>>>|^><cursor>>|<cell|>|<cell|a<suppressed|<explicit-space>><wide|<suppressed|<tiny-box>>+<suppressed|<tiny-box>>|^><suppressed|<explicit-space>>b>>>>>
        </equation*>
      </hidden*>|<\hidden*>
        <item><strong|Wildly varying notations for quantified expressions>

        <\equation*>
          <tabular*|<tformat|<table|<row|<cell|\<forall\>x,\<exists\>y,P<around*|(|x,y|)>>>|<row|<cell|\<forall\>x\<exists\>y:P<around*|(|x,y|)>>>|<row|<cell|<around*|(|\<forall\>x|)><around*|(|\<exists\>y|)>P<around*|(|x,y|)>>>|<row|<cell|\<vdots\>>>>>>
        </equation*>

        <\equation*>
          \<forall\>x,<cursor><suppressed|<tiny-box>><space|1em><long-arrow|\<rubber-rightarrow\>|<key|E
          tab tab>><space|1em>\<forall\>x,\<exists\><cursor><suppressed|<tiny-box>,<tiny-box>>
        </equation*>
      </hidden*>>
    </itemize>
  </hidden>|<\hidden>
    <tit|Remaining problems and challenges (continued)>

    <\itemize>
      <unroll|<\shown>
        <item><strong|Implicit zeros and such>

        <\equation*>
          <matrix|<tformat|<table|<row|<cell|<suppressed|<tiny-box>>>|<cell|<suppressed|<tiny-box>>>>|<row|<cell|<suppressed|<tiny-box>>>|<cell|<suppressed|<tiny-box>>>>>>><space|1em><text|versus><space|1em><matrix|<tformat|<table|<row|<cell|\<lambda\><rsub|1>>|<cell|>|<cell|>>|<row|<cell|>|<cell|\<ddots\>>|<cell|>>|<row|<cell|>|<cell|>|<cell|\<lambda\><rsub|n>>>>>>
        </equation*>
      </shown>|<\hidden*>
        <item><strong|How permissive should the universal grammar be?>

        <\eqnarray*>
          <tformat|<table|<row|<cell|f<rsub|n;>>|<cell|=>|<cell|f<rsub|n>*z<rsup|n>+f<rsub|n+1>*z<rsup|n+1>+\<cdots\>>>|<row|<cell|L<rsub|\<times\>f><around*|(|g|)>>|<cell|=>|<cell|L<around*|(|f*g|)>>>>>
        </eqnarray*>

        <\equation*>
          f<rsub|n<cursor>><space|1em><long-arrow|\<rubber-rightarrow\>|<key|;>><space|1em><math-ordinary|???>
        </equation*>
      </hidden*>|<\hidden*>
        <item><strong|Undoing \Psave the current selection as an image\Q>
      </hidden*>|<\hidden*>
        <item><strong|Increased semantics?> Replace <math|y> by <math|a+b> in
        <math|x\<cdot\>y> <math|\<rightsquigarrow\>> <math|x\<cdot\>a+b> or
        <math|x\<cdot\><around*|(|a+b|)>>?
      </hidden*>|<\hidden*>
        <item><strong|Unclear semantics for certain expressions>

        Differences between <math|a+b*c-d> and <math|a+b*c*y> yield
        <math|a+b*c<with|color|dark red|-d><with|color|dark green|*y>> in
        versioning tool.
      </hidden*>>
    </itemize>
  </hidden>>
</body>

<\initial>
  <\collection>
    <associate|info-flag|minimal>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|chirp-formula|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|failed-step|<tuple|3|?>>
    <associate|it-log|<tuple|?|4>>
    <associate|log-slow-cond|<tuple|?|19>>
    <associate|mersenne-conj|<tuple|1|21>>
    <associate|split-prop|<tuple|1|?>>
    <associate|tab:mmx|<tuple|1|?>>
    <associate|wrap-fig|<tuple|?|?>>
  </collection>
</references>